/*
 * @(#)IpAddrChecker.java    1.00   03/18/05
 *
 * Copyright (c) 2005 Agilis Software LLC, Fremont, CA, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Agilis Software LLC ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered
 * into with Agilis Software LLC.
 */

import java.net.*;
import com.vs.ezlicrun.*;

/*
 * This is a code fragment that illustrates how to plug in static IP
 * address checks into an EasyLicenser-enabled Java application.
 * The code fragment is incomplete code intended to be used as a 
 * head start, and will not compile by itself.
 *
 * The platform-independent implementation scans all available 
 * IP addresses for a value that matches the input.
 *
 * DISCLAIMER: this code is provided as-is.
 */

public class IpAddrChecker implements EzLicCustomLicenseInterface
{

	public int checkCustomKeyCode(String valStr, Object ctx) throws EzLicExceptionBase {
		// An instance of IpAddrChecker is passed in as the custom key handler
		// parameter to the license check API call.
		// IpAddr is the static IP address embedded as the custom key value.
		// ctx is the custom key handler context passed in as a parameter to the
		// license check API call - not used.
		// Code works on a multihomed host.
		// Note: in this simple example, the custom key value contains just the
		// static IP address against which node locking is to occur. In a more
		// sophisticated scenario, the custom key may contain arbitrary information
		// which would be parsed to retrieve its components including the Ip addr.
		String IpAddr = valStr;
		InetAddress localHost = null;
		InetAddress[] allHosts = null;
		try {
			localHost = InetAddress.getLocalHost();
			allHosts = InetAddress.getAllByName(localHost.getHostName());
		} catch (Throwable t) {
        	EzLicExceptionBase.throwLicenseException(
        		EzLicExceptionBase.EZLIC_EXC_INTERNAL, 
        			"Unexpected Exception: " + t.getClass().getName() + ", Message: " + t.getMessage());
		}
		boolean found = false;
		for (int i = 0; i < allHosts.length; i++) {
			if (IpAddr.equals(allHosts[i].getHostAddress())) {
				found = true;
				break;
			}
		}
		if (!found) {
			EzLicExceptionBase.throwLicenseException(
				EzLicExceptionBase.EZLIC_EXC_INVALID_HOST_USER_NET , " Unlicensed IP Address (ensure you're not using DHCP)");
		}
		// add'l custom key handling code if any
    	return 0;
  	}

}
